<?php

// QuickTalk 1.9.0.3 build:20081001

class cTopic
{

// --------

var $id = -1;
var $numid = -1;
var $section = -1;
var $type = 'T';
var $status = '0'; // 0=open 1=closed
var $hottopic = '';  // if is hot topic, value '_h'
var $firstpostid = -1;
var $lastpostid = -1; 
var $firstpostuser = -1;
var $lastpostuser = -1;
var $firstpostname;
var $lastpostname;
var $firstpostdate = '0';
var $lastpostdate = '0';
var $replies = 0;
var $views = 0;
var $youreply = '&nbsp;';
var $smile;
var $title;

// -- Constructor method (accept an array or a cTopic as parameter #1) --

function cTopic($aTopic=null,$intUser=-1,$intPreviewsize=250)
{
  if ( isset($aTopic) )
  {    
    if ( is_int($aTopic) )
    {
      if ( $aTopic<0 ) die('cTopic: Wrong id');
      global $oDB;
      $oDB->Query('SELECT * FROM '.TABTOPIC.' WHERE id='.$aTopic);
      $row =  $oDB->Getrow();
      if ( $row===False ) die('No topic '.$aTopic);
      $this->MakeFromArray($row,$intPreviewsize);
      if ( $intUser>=0 )
      {
        // +1 when user is not the topic creator himself
        if ( $intUser != $this->firstpostuser )
        {
        $oDB->Query('UPDATE '.TABTOPIC.' SET views = views+1 WHERE id='.$this->id);
        }
      }
    }
    elseif ( is_array($aTopic) )
    {
      $this->MakeFromArray($aTopic,$intPreviewsize);
    }
    elseif ( strtolower(get_class($aTopic))=='ctopic' )
    {
      $this->id            = $aTopic->id;
      $this->numid         = $aTopic->numid;
      $this->section       = $aTopic->section;
      $this->type          = $aTopic->type;
      $this->status        = $aTopic->status;
      $this->firstpostid   = $aTopic->firstpostid;
      $this->lastpostid    = $aTopic->lastpostid; 
      $this->firstpostuser = $aTopic->firstpostuser; 
      $this->lastpostuser  = $aTopic->lastpostuser; 
      $this->firstpostname = $aTopic->firstpostname; 
      $this->lastpostname  = $aTopic->lastpostname; 
      $this->firstpostdate = $aTopic->firstpostdate; 
      $this->lastpostdate  = $aTopic->lastpostdate; 
      $this->replies       = $aTopic->replies; 
      $this->views         = $aTopic->views;
      $this->youreply      = $aTopic->youreply;
      $this->smile         = $aTopic->smile; 
      $this->title         = $aTopic->title; 
      $this->preview       = $aTopic->preview;
    }
    else
    {
      die('Invalid constructor parameter #1 in the class cTopic');
    }
    if ( QTF_HOTTOPICS )
    {
      if ( $this->replies>=QTF_HOTTOPICS ) $this->hottopic = '_h';
    }
  }
  
}

// --------

function MakeFromArray($aTopic,$intPreviewsize=100)
{
  foreach ($aTopic as $strKey => $oValue) {
  switch ($strKey) {
    case 'textmsg':
      $this->preview = $oValue;
      $this->preview = QTbbc($this->preview,'deepdrop',' ',$intPreviewsize,null,null,''); 
      break;
    case 'id':           $this->id           = intval($oValue); break;
    case 'numid':        $this->numid        = intval($oValue); break;
    case 'forum':        $this->section      = intval($oValue); break;
    case 'type':         $this->type         = $oValue; break;
    case 'status':       $this->status       = $oValue; break;
    case 'firstpostid':  $this->firstpostid  = intval($oValue); break;
    case 'lastpostid':   $this->lastpostid   = intval($oValue); break;
    case 'firstpostuser':$this->firstpostuser= intval($oValue); break;
    case 'lastpostuser': $this->lastpostuser = intval($oValue); break;
    case 'firstpostname':$this->firstpostname= $oValue; break;
    case 'lastpostname': $this->lastpostname = $oValue; break;
    case 'firstpostdate':$this->firstpostdate= $oValue; break;
    case 'lastpostdate': $this->lastpostdate = $oValue; break;
    case 'replies':      $this->replies      = intval($oValue); break;
    case 'views':        $this->views        = intval($oValue); break;
    case 'icon':         $this->smile        = $oValue; break;
    case 'title':        $this->title        = $oValue; break;
  }}
}

// --------

function GetTopicTitle()
{
  global $oDB;
  $oDB->Query('SELECT title FROM '.TABPOST.' WHERE id='.$this->firstpostid);
  $row = $oDB->Getrow();
  $this->title = $row['title'];
  return $this->title;
}

// -------- (can be used without object instance)

function SetStatus($intId=-1,$str='1')
{
  if ( $intId<0 ) die('Wrong id in topic->SetStatus');
  global $oDB;
  $oDB->Query('UPDATE '.TABTOPIC.' SET status="'.$str.'" WHERE id='.$intId);
  if ( isset($this) ) $this->status=$str;
  }

// -------- can be used without object instance)

function SetType($intId=-1,$str='T')
{
  if ( $intId<0 ) die('Wrong id in topic->SetType');
  global $oDB;  
  $oDB->Query('UPDATE '.TABTOPIC.' SET type="'.$str.'" WHERE id='.$intId);
  if ( isset($this) ) $this->type=$str;
}

// --------

function UpdateTopicStats($id=-1,$intMax=100,$oLastPost=null)
{
  if ( $id<0 ) die('Topic->UpdateTopicStats: Wrong id');

  global $oDB;

  // query topics
  $oDB->Query( 'SELECT count(id) as countid FROM '.TABPOST.' WHERE type="R" AND topic='.$id );
  $row = $oDB->Getrow();
  $this->replies = intval($row['countid']);

  $strQ = '';
  if ( isset($oLastPost) )
  {
  $this->lastpostid = $oLastPost->id;
  $this->lastpostuser = $oLastPost->userid;
  $this->lastpostname = $oLastPost->username;
  $this->lastpostdate = $oLastPost->issuedate;
  $strQ = ', lastpostid='.$this->lastpostid.', lastpostuser='.$this->lastpostuser.',lastpostname="'.$this->lastpostname.'", lastpostdate="'.$this->lastpostdate.'"';
  }

  // save stats
  $oDB->Query( 'UPDATE '.TABTOPIC.' SET replies='.$this->replies.$strQ.' WHERE id='.$id );

  // close topic if full
  if ( $this->replies>=$intMax )
  {
  $oDB->Query('UPDATE '.TABTOPIC.' SET status="1" WHERE id='.$id);
  }
}

// --------

function InsertTopic($bUserStat=true)
{
  global $oDB;
  $oDB->Query(
  'INSERT INTO '.TABTOPIC." (
  id,forum,numid,type,status,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate,replies)
  VALUES (
  $this->id,
  $this->section,
  $this->numid,
  \"$this->type\",
  \"$this->status\",
  $this->firstpostid,
  $this->lastpostid,
  $this->firstpostuser,
  $this->lastpostuser,
  \"$this->firstpostname\",
  \"$this->lastpostname\",
  \"".date('Ymd His')."\",
  \"".date('Ymd His')."\",$this->replies)"
  );
  
  Unset($_SESSION[QT]['sys_topics']);

  if ( $bUserStat ) 
  {
  if ( isset($_SESSION['qtf_usr_posts']) ) $_SESSION['qtf_usr_posts']++;
  $oDB->Query('SELECT count(*) as countid FROM '.TABPOST.' WHERE userid='.$this->firstpostuser);
  $row = $oDB->Getrow();
  $oDB->Query('UPDATE '.TABUSER.' SET lastdate="'.date('Ymd His').'", numpost='.$row['countid'].', ip="'.$oDB->ip.'" WHERE id='.$this->firstpostuser);
  $_SESSION[QT.'_usr_posts']++;
  }
}

// --------

}

?>