<?php

// QuickTalk 1.9.0.3 build:20081001

ob_start();

HtmlDtd();

// ========
if ( !isset($bToPrint) ) {
// ========

// --------
// INITIALISE
// --------

// check Welcome condition

$bWelcome = true;
if ( in_array($oVIP->selfurl,array('qtf_usr_new.php','qtf_form_reg.php','qtf_cmd.php')) ) $bWelcome = false;
if ( $_SESSION[QT]['sys_welcome']=='0' ) $bWelcome = false;
if ( $_SESSION[QT]['sys_welcome']=='1' && $oVIP->auth) $bWelcome = false;
if ( $_SESSION[QT]['board_offline']=='1' ) $bWelcome = false;
if ( !file_exists($_SESSION[QT]['language'].'/sys_welcome.txt') ) $bWelcome = false;

// check LangMenu condition

$strLangMenu = '';
if ( $_SESSION[QT]['userlang']=='1' )
{
  if ( file_exists('bin/qtf_lang.php') )
  {
    include('bin/qtf_lang.php');
    $strURI = QTargimplode(QTargadd(QTargexplode(),'lx'));
    $strLangMenu = '';
    foreach ($arrLang as $strKey => $arrDef)
    {
    $strLangMenu .= '<a href="'.$oVIP->selfurl.'?'.$strURI.'&amp;lx='.$strKey.'" title="'.$arrDef[1].'" class="'.($_SESSION[QT]['show_banner']=='1' ? 'a_banner' : 'a_nobanner').'">'.$arrDef[0].'</a>&nbsp;';
    }
  }
  else
  {
    $strLangMenu .= '<span class="small">missing file:bin/qtf_lang.php</span>';
  }
}  

// check header content

$bLegend = true;
if ( $_SESSION[QT]['board_offline']=='1' ) $bLegend=false;
if ( $_SESSION[QT]['show_legend']!='1' ) $bLegend=false;
if ( !in_array($oVIP->selfurl,array('index.php','qtf_index.php','qtf_topics.php','qtf_calendar.php','qtf_topic.php','qtf_search_id.php','qtf_search_ov.php','qtf_search_kw.php','qtf_search_st.php')) ) $bLegend=false;

if ( !isset($arrCss) ) $arrCss=array();
if ( $bLegend ) $arrCss[]='qtf_legend.css';
if ( isset($strHeaderAddCss) ) $arrCss[]=$strHeaderAddCss;

// --------
// HTML START
// --------

HtmlHead('','',$arrCss,(isset($strHeaderAddScript) ? $strHeaderAddScript : ''),(isset($arrJava) ? $arrJava : null));

echo '
<body'.(isset($strBodyAddOnload) ? ' onload="'.$strBodyAddOnload.'"': '').(isset($strBodyAddOnunload) ? ' onunload="'.$strBodyAddOnunload.'"': '').'>
';

// PAGE

HtmlPageCtrl(0,$_SESSION[QT]['site_width']);

// BANNER

if ( $_SESSION[QT]['show_banner']=='1' )
{
  HtmlBanner(0,'','qtf_logo.gif',$strLangMenu);
}
else
{
  if ( !empty($strLangMenu) )
  {
  HtmlBanner(1,'','',$strLangMenu);
  }
}

// MENU LINE

echo '<!-- MENU LINE -->',N;
echo '<table class="ta_menu" cellspacing="0">',N;
echo '<tr class="tr_menu">',N;

  // user icon
  echo '<td class="td_menu_ico">',($oVIP->role=='V' ? AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_0.gif','-',$L['Ico_user_p_0'],'ico_user') : AsImg($_SESSION[QT]['skin_dir'].'/ico_user_p_1.gif','-',$L['Ico_user_p_1'],'ico_user')),'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;

  // user name
  echo '<td class="td_menu_usr">&nbsp;',($oVIP->role=='V' ? $L['Userrole']['V'] : $oVIP->username),'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;

  // menu home
  if ( $_SESSION[QT]['home_menu']=='1' && !empty($_SESSION[QT]['home_url']) )
  {
  echo '<td class="td_menu"><a class="a_menu" href="',$_SESSION[QT]['home_url'], '">', ( empty($_SESSION[QT]['home_name']) ? "Home" : $_SESSION[QT]['home_name'] ),'</a></td>',N;
  echo '<td class="td_menu_sep"></td>',N;
  }
    
  // menu memberlist
  $strMenu    = '<a class="a_menu" href="qtf_members.php">'.$L['Memberlist'].'</a>';
  $strMenuOff = '<span class="a_menu_off">'.$L['Memberlist'].'</span>';
  if ( $_SESSION[QT]['board_offline']=='1' ) $strMenu = $strMenuOff;
  if ( $oVIP->role=='V' && $_SESSION[QT]['visitor_right']<4 ) $strMenu = $strMenuOff;
  if ( $oVIP->selfurl=='qtf_members.php' ) $strMenu = $strMenuOff;
  echo '<td class="td_menu"',($oVIP->selfurl=='qtf_members.php' ? ' id="zone_menu_actif"' : ''),'>',$strMenu,'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;

  // menu search
  $str = '';  if ( substr($oVIP->selfurl,0,14)=='qtf_search' ) $str = 'id="zone_menu_actif"';
  $strMenu = '<a class="a_menu" href="qtf_search.php">'.$L['Search'].'</a>';
  $strMenuOff = '<span class="a_menu_off">'.$L['Search'].'</span>';
  if ( $_SESSION[QT]['board_offline']=='1' ) $strMenu = $strMenuOff;
  if ( $oVIP->role=='V' && $_SESSION[QT]['visitor_right']<5 ) $strMenu = $strMenuOff;
  if ( $oVIP->selfurl=='qtf_search.php' ) $strMenu = $strMenuOff;
  echo '<td class="td_menu" ',$str,'>',$strMenu,'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;

  // menu profile/logout
  if ( !$oVIP->auth )
  {
  $str = '';  if ( $oVIP->selfurl=='qtf_usr_new.php' || $oVIP->selfurl=='qtf_form_reg.php' ) $str = 'id="zone_menu_actif"';
  echo '<td class="td_menu" ',$str,'>',($oVIP->selfurl=='qtf_usr_new.php' || $_SESSION[QT]['board_offline']=='1' ? '<span class="a_menu_off">'.$L['Register'].'</span>' : '<a class="a_menu" href="qtf_usr_new.php">'.$L['Register'].'</a>'),'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;
  $str = '';  if ( $oVIP->selfurl=='qtf_usr_login.php' || $oVIP->selfurl=='qtf_usr_pwd_for.php' ) $str = 'id="zone_menu_actif"';
  echo '<td class="td_menu" ',$str,'>',($oVIP->selfurl=='qtf_usr_login.php' ? '<span class="a_menu_off">'.$L['Login'].'</span>' : '<a class="a_menu" href="qtf_usr_login.php">'.$L['Login'].'</a>'),'</td>',N;
  }
  else
  {
  $str = '';  if ( substr($oVIP->selfurl,0,7)=='qtf_usr' ) $str = 'id="zone_menu_actif"';
  echo '<td class="td_menu" ',$str,'>',($_SESSION[QT]['board_offline']=='1' ? '<span class="a_menu_off">'.$L['Profile'].'</span>' : '<a class="a_menu" href="qtf_usr.php?id='.$oVIP->id.'">'.$L['Profile'].'</a>'),'</td>',N;
  echo '<td class="td_menu_sep"></td>',N;
  echo '<td class="td_menu"',($oVIP->selfurl=='qtf_usr_login.php?a=out' ? ' id="zone_menu_actif"' : ''),'>'.($oVIP->selfurl=='qtf_usr_logout.php' ? '<span class="a_menu_off">'.$L['Logout'].'</span>' : '<a class="a_menu" href="qtf_usr_login.php?a=out">'.$L['Logout'].'</a>').'</td>',N;
  }

echo '</tr>',N;
echo '</table>',N;
echo '<!-- END MENU LINE -->',N,N;

// WELCOME

if ( $bWelcome )
{
echo '
<!-- welcome message -->
<div class="div_welcome">
<div class="div_welcome_in">
';
include($_SESSION[QT]['language'].'/sys_welcome.txt');
echo '
</div>
</div>
<!-- end welcome message -->
';
}

// LINE START

echo '
<!-- BODY -->
<div class="div_body"><div class="div_body_in">
<!-- BODY TOP -->
<table class="ta_body_hd" cellspacing="0">
<tr class="tr_body_hd">
<td class="td_body_hd_l"><img class="img_body_hd_l" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_left.gif" alt=""/></td>
<td class="td_body_hd_c"><a class="a_body_hd" href="qtf_index.php">',ObjectName('index','i',$_SESSION[QT]['index_name']),'</a>';

if (isset($oSEC))
{
  echo QTF_CRUMBTRAIL,'<a class="a_body_hd" href="qtf_topics.php?s=',$oSEC->id,'">',(QTF_SHOW_DOMAIN ? $oSEC->domname.': ' : ''),$oSEC->name,'</a>';
  if ( isset($oTopic) )
  {
    if ( $oTopic->numid>=0 && $oSEC->numfield!='N' ) echo QTF_CRUMBTRAIL,sprintf($oSEC->numfield,$oTopic->numid);
  }
}

echo '</td>',N;

echo '<td class="td_body_hd_c" style="text-align:right">&nbsp;';

switch($oVIP->selfurl)
{
case 'qtf_stats.php':
  $strURI = QTargimplode(QTargadd(QTargexplode(),'view'));
  break;
case 'qtf_topic.php':
  $strURI = QTargimplode(QTargadd(QTargexplode(),'view'));

  if ( $_SESSION[QT]['viewmode']=='C' )
  {
  echo '<a href="',$oVIP->selfurl,'?',$strURI,'&amp;view=N"><img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/></a>&nbsp;';
  echo '<img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/>';
  }
  else
  {
  echo '<img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/>&nbsp;';
  echo '<a href="',$oVIP->selfurl,'?',$strURI,'&amp;view=C"><img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/></a>';
  }
  break;
case 'qtf_members.php':
  if ( !empty($_SESSION[QT]['avatar']) )
  {
    if ( $_SESSION[QT]['viewmode']=='C' )
    {
    echo '<a href="qtf_members.php?view=N"><img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/></a>&nbsp;';
    echo '<img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/>';
    }
    else
    {
    echo '<img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_n.gif" title="',$L['Ico_view_n'],'" alt="N"/>&nbsp;';
    echo '<a href="qtf_members.php?view=C"><img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_c.gif" title="',$L['Ico_view_c'],'" alt="C"/></a>';
    }
  }
  break;
}

if ( QTF_SHOW_PRINT ) {
if ( file_exists(substr($oVIP->selfurl,0,-4).'_prt.php') ) {
  echo '&nbsp;<a href="',substr($oVIP->selfurl,0,-4),'_prt.php',(isset($strURI) ? '?'.$strURI : ''),'"><img class="ico ico_modes" src="',$_SESSION[QT]['skin_dir'],'/ico_view_p.gif" title="',$L['Ico_view_p'],'" alt="P"/></a>';
}}
echo '</td>',N;

echo '<td class="td_body_hd_r"><img class="ico_body_hd_r" src="',$_SESSION[QT]['skin_dir'],'/ico_hd_right.gif" alt=""/></td>',N;
echo '</tr>',N;
echo '</table>',N;
echo '<!-- END BODY TOP -->',N,N;

// BODY START

echo '<!-- BODY MAIN -->',N;
echo '<table width="100%" cellspacing="0" class="ta_body"><tr class="tr_body"><td class="td_body">',N;
echo '<!-- BODY MAIN -->',N,N;

// ========
} else {
// ========

echo '<head>
<title>',$_SESSION[QT]['site_name'],'</title>
<meta http-equiv="content-type" content="text/html; charset=',QTF_HTML_CHAR,'"/>
<link rel="shortcut icon" href="',$_SESSION[QT]['skin_dir'],'/qtf_icon.ico"/>
<link rel="stylesheet" type="text/css" href="',$_SESSION[QT]['skin_dir'],'/qtf_print.css"/>',N;
if ( isset($strHeaderAddScript) ) echo $strHeaderAddScript,N;
echo '</head>

<body'.(isset($strBodyAddOnload) ? ' onload="'.$strBodyAddOnload.'"': '').(isset($strBodyAddOnunload) ? ' onunload="'.$strBodyAddOnunload.'"': '').'>';

// BANNER

if ( $_SESSION[QT]['show_banner']=='1' ) Htmlbanner(2,$_SESSION[QT]['skin_dir'],'qtf_logo_prt.gif');

// ========
}
// ========

?>